package javasamp;

import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.IOException;

public class dbg
   {
                                       /* is con debugging turned on?        */
   static boolean con_debugging;
                                       /* stream to send debug output to     */
   static PrintStream ps;

   public static void print(String str)
      {
      if (con_debugging)
         {
         System.out.println(str);
         }

      if (ps != null)
         {
         ps.println(str);
         }
      }

   /**************************************************************************/
   /* Dump a hex formatted buffer of data to output device                   */
   /**************************************************************************/
   public static void hexlog(byte [] buf, String label)
      {
      String OutStr = "";
      int x, y=0;
      int hdrlen = label.length() + 8;
      String temp;

      for (x=0;x<buf.length;x++)
         {
         if ((x % 16) == 0)
            {
            if (OutStr.length() != 0)
               {
               print(OutStr);
               }

            OutStr = " " + label + " " + FormatHexString(x, 4) +
                ":                                         *                *";
            y = 0;
            }

         temp = FormatHexString((int)buf[x], 2);
         OutStr = OutStr.substring(0, hdrlen + (y*2) + (y/2))
                         + temp + OutStr.substring(hdrlen + (y*2) + (y/2) + 2);
         if ((buf[x] >= 32) && (buf[x] <= 126))
            {
            OutStr = OutStr.substring(0, hdrlen + 40 + y +1) + (char)buf[x] +
                                         OutStr.substring(hdrlen + 40 + y + 2);
            }

         y++;
         }

      print(OutStr);
      }

   public static String FormatHexString(int Number, int MaxLen)
      {
      String    OutStr;

      OutStr = Integer.toHexString(Number);

      if (OutStr.length() > MaxLen)
         {
         OutStr = OutStr.substring(OutStr.length()-1-MaxLen,
         OutStr.length()-1);
         }
      else if (OutStr.length() < MaxLen)
         {
         while (OutStr.length() < MaxLen)
            {
            OutStr = "0" + OutStr;
            }
         }

      return OutStr;
      }

   /**************************************************************************/
   /* Look for commands that affect debugging output in the arg list         */
   /**************************************************************************/
   static void init(String  dbgstr)
      {
      if (dbgstr.equalsIgnoreCase("con"))
         {
         con_debugging = true;
         }
      else if (dbgstr.equalsIgnoreCase("file") ||
                                            dbgstr.equalsIgnoreCase("filetee"))
         {
         if (dbgstr.equalsIgnoreCase("filetee"))
            {
            con_debugging = true;
            }

         try
            {
            FileOutputStream fos = new FileOutputStream("javasamp.log");
            ps = new PrintStream(fos);
            }
         catch (IOException ie)
            {
            handleException(ie);
            }
         }
      }

   public static void printStackTrace(Throwable t)
      {
//    print(t.toString());
      if (con_debugging)
         {
         t.printStackTrace();
         }
      if (ps != null)
         {
         t.printStackTrace(ps);
         }
      }

   public static void handleException(IOException ie)
      {
      System.err.println(ie.toString());
      ie.printStackTrace(System.err);
      }

   public static void flush_and_close()
      {
      if (ps != null)
         {
         ps.flush();
         ps.close();
         }
      }

   public static boolean isDebugging()
      {
      if (ps != null || con_debugging)
         return true;
      else
         return false;
      }

   static
      {
                                       /* initialize to no logging           */
      con_debugging = false;
      ps = null;
      init("filetee");
      }
   }
